
package de.ivu.elect.presentation.gruppe.menu;

import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.presentation.ergebnis.menu.ErgebnisMenuDisabled;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public abstract class AbstractGruppeKumulierteStimmenAnzeigenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlSessionSelect wahlSessionSelect;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  public AbstractGruppeKumulierteStimmenAnzeigenMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(getRequiredUseCasePermission()) && isWahlSelected() && (getWahl().isWahlMitListengebieten() || getWahl().isWahlMitDirektkandidatengebieten());
  }

  protected abstract UseCasePermission getRequiredUseCasePermission();

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this); // wegen ELECTMUC-988 auch schon vor Ergebnisberechnung anzeigen
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCalculate();
  }

  private boolean isWahlSelected() {
    return wahlSessionSelect.isSelected();
  }

  private Wahl getWahl() {
    return wahlSessionSelect.getEntity();
  }
}
